package com.hfkj.dao;

import com.hfkj.entity.BsOrderCouponNo;
import com.hfkj.entity.BsOrderCouponNoExample.Criteria;
import com.hfkj.entity.BsOrderCouponNoExample.Criterion;
import com.hfkj.entity.BsOrderCouponNoExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderCouponNoSqlProvider {

    public String countByExample(BsOrderCouponNoExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_coupon_no");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderCouponNoExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_coupon_no");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderCouponNo record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_coupon_no");
        
        if (record.getCouponOrderId() != null) {
            sql.VALUES("coupon_order_id", "#{couponOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.VALUES("channel_order_no", "#{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsVpdSource() != null) {
            sql.VALUES("goods_vpd_source", "#{goodsVpdSource,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsVpdKey() != null) {
            sql.VALUES("goods_vpd_key", "#{goodsVpdKey,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsVpdSourceCouNo() != null) {
            sql.VALUES("goods_vpd_source_cou_no", "#{goodsVpdSourceCouNo,jdbcType=VARCHAR}");
        }
        
        if (record.getExpireStatus() != null) {
            sql.VALUES("expire_status", "#{expireStatus,jdbcType=BIT}");
        }
        
        if (record.getExpireTime() != null) {
            sql.VALUES("expire_time", "#{expireTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExceptionStatus() != null) {
            sql.VALUES("exception_status", "#{exceptionStatus,jdbcType=BIT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDeliverTime() != null) {
            sql.VALUES("deliver_time", "#{deliverTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderCouponNoExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("coupon_order_id");
        sql.SELECT("order_no");
        sql.SELECT("channel_order_no");
        sql.SELECT("goods_vpd_source");
        sql.SELECT("goods_vpd_key");
        sql.SELECT("goods_vpd_source_cou_no");
        sql.SELECT("expire_status");
        sql.SELECT("expire_time");
        sql.SELECT("`status`");
        sql.SELECT("exception_status");
        sql.SELECT("create_time");
        sql.SELECT("deliver_time");
        sql.SELECT("finish_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_coupon_no");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderCouponNo record = (BsOrderCouponNo) parameter.get("record");
        BsOrderCouponNoExample example = (BsOrderCouponNoExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_coupon_no");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCouponOrderId() != null) {
            sql.SET("coupon_order_id = #{record.couponOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsVpdSource() != null) {
            sql.SET("goods_vpd_source = #{record.goodsVpdSource,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsVpdKey() != null) {
            sql.SET("goods_vpd_key = #{record.goodsVpdKey,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsVpdSourceCouNo() != null) {
            sql.SET("goods_vpd_source_cou_no = #{record.goodsVpdSourceCouNo,jdbcType=VARCHAR}");
        }
        
        if (record.getExpireStatus() != null) {
            sql.SET("expire_status = #{record.expireStatus,jdbcType=BIT}");
        }
        
        if (record.getExpireTime() != null) {
            sql.SET("expire_time = #{record.expireTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExceptionStatus() != null) {
            sql.SET("exception_status = #{record.exceptionStatus,jdbcType=BIT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDeliverTime() != null) {
            sql.SET("deliver_time = #{record.deliverTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_coupon_no");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("coupon_order_id = #{record.couponOrderId,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("channel_order_no = #{record.channelOrderNo,jdbcType=VARCHAR}");
        sql.SET("goods_vpd_source = #{record.goodsVpdSource,jdbcType=INTEGER}");
        sql.SET("goods_vpd_key = #{record.goodsVpdKey,jdbcType=VARCHAR}");
        sql.SET("goods_vpd_source_cou_no = #{record.goodsVpdSourceCouNo,jdbcType=VARCHAR}");
        sql.SET("expire_status = #{record.expireStatus,jdbcType=BIT}");
        sql.SET("expire_time = #{record.expireTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("exception_status = #{record.exceptionStatus,jdbcType=BIT}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("deliver_time = #{record.deliverTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderCouponNoExample example = (BsOrderCouponNoExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderCouponNo record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_coupon_no");
        
        if (record.getCouponOrderId() != null) {
            sql.SET("coupon_order_id = #{couponOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getChannelOrderNo() != null) {
            sql.SET("channel_order_no = #{channelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsVpdSource() != null) {
            sql.SET("goods_vpd_source = #{goodsVpdSource,jdbcType=INTEGER}");
        }
        
        if (record.getGoodsVpdKey() != null) {
            sql.SET("goods_vpd_key = #{goodsVpdKey,jdbcType=VARCHAR}");
        }
        
        if (record.getGoodsVpdSourceCouNo() != null) {
            sql.SET("goods_vpd_source_cou_no = #{goodsVpdSourceCouNo,jdbcType=VARCHAR}");
        }
        
        if (record.getExpireStatus() != null) {
            sql.SET("expire_status = #{expireStatus,jdbcType=BIT}");
        }
        
        if (record.getExpireTime() != null) {
            sql.SET("expire_time = #{expireTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExceptionStatus() != null) {
            sql.SET("exception_status = #{exceptionStatus,jdbcType=BIT}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDeliverTime() != null) {
            sql.SET("deliver_time = #{deliverTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderCouponNoExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}